#include "player.h"
#include "pouch.h"
#include "extern.h"
#include "flags.h"
#include <string>
#include <stdio.h>

using namespace std;

void Player::reset()
{
    exp = 1;
    gold = 0;
    bank = 500;
    hp = 10;
    maxhp = 10;
    strength = 0;
    defense = 0;
    armor = 1;
    weapon = 1;
    level = 1;
    forest_fights = forestfights;
    player_fights = 3;
    fight = NULL;
    master = NULL;
    battle = NULL;
    flags = 0;
    lastcommand = 0;
    lastlogin = 0;
    setAlive(this);
    inventory.reset();
}

Player::Player()
{
    setData(NULL);

    #ifdef DEBUGMODE
	log("New Player: %s", name.c_str());
    #endif
}

Player::Player(aClient *user)
{

    if (user)
    {
	setData(user->stats);
	name = user->getNick();
    }
    else
	setData(NULL);
}

Player::Player(char *n)
{
    reset(); // Set defaults

    name = n;

    #ifdef DEBUGMODE
	log("New Player: %s", name.c_str());
    #endif
}

Player::Player(string n)
{
    reset();
    name = n;
    #ifdef DEBUGMODE
	log("New Player: %s", name.c_str());
    #endif
}

Player::~Player()
{   
    #ifdef DEBUGMODE
	string *output;
	output = new string("Deleting Player");
    #endif
 
    #ifdef DEBUGMODE
	 *output += ": " + name;
    #endif

    #ifdef DEBUGMODE
	*output += "    Password: " + password;
	log ("%s", output->c_str());
	delete output;
    #endif
}
void Player::setPassword(const char *p)
{
      static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUV\
WXYZ0123456789./";
      static char salt[3];

      salt[0] = saltChars[rand() % strlen(saltChars)];
      salt[1] = saltChars[rand() % strlen(saltChars)];
      salt[2] = '\0';

      password = crypt(p, salt);
}

void Player::setData(Player *right)
{
    if (right)
    {
	name = right->name;
	password = right->password;
        exp = right->exp;
        gold = right->gold;
        bank = right->bank;
        hp = right->hp;
        maxhp = right->maxhp;
        strength = right->strength;
        defense = right->defense;
        armor = right->armor;
        weapon = right->weapon;
        level = right->level;
        forest_fights = right->forest_fights;
        player_fights = right->player_fights;
	flags = right->flags;
	inventory.setInventory(&right->inventory);
	client = right->client;
	lastcommand = right->lastcommand;
	lastlogin = right->lastlogin;
    }
    else
    {
	char *temp;
        reset();
	temp = new char[16];
	client = NULL;
	int num = rand() % 32767;
	snprintf(temp, 16, "Player: %d", num);
	name = temp;
	delete []temp;
    }

    #ifdef DEBUGMODE
	log("Setting Player data for %s", name.c_str());
    #endif
}

monster_::~monster_()
{
}

monster_::monster_()
{
    name.erase();
    weapon.erase();
    death.erase();
    strength = 0;
    defense = 0;
    exp = 0;
    gold = 0;
    maxhp = hp = 0;
}

monster_::monster_(monster_ *m)
{
    name = m->name;
    weapon = m->weapon;
    death = m->death;
    strength = m->strength;
    defense = m->defense;
    maxhp = m->maxhp;
    hp = m->hp;
    gold = m->gold;
    exp = m->exp;
}

monster_::monster_(monster_ &m)
{
    name = m.name;
    weapon = m.weapon;
    death = m.death;
    strength = m.strength;
    defense = m.defense;
    maxhp = m.maxhp;
    hp = m.hp;
    gold = m.gold;
    exp = m.exp;
}

long int Player::setFlags(long int newflags)
{
    flags = newflags;
    return getFlags();
}

long int Player::addFlag(long int flag)
{
    flags |= flag;
    return getFlags();
}

long int Player::remFlag(long int flag)
{
    flags &= ~flag;
    return getFlags();
}

Pouch::Pouch(int h, int s, int d)
{
    setHealing(h);
    setStrength(s);
    setDefense(d);
}
